Subject: Re: bug#11046: 24.0.94; Customize: M-TAB moves cursor over tag; clicking button moves cursor over button

From: Mauro Aranda <[email-masked]>
Date: Mon, 30 Sep 2019 13:08:50 -0300

Eli Zaretskii <[email-masked]> writes:

>> From: "Drew Adams" <[email-masked]>
>> Date: Tue, 20 Mar 2012 09:02:30 -0700
>>
>> emacs -Q
>>
>> M-x customize-option RET site-run-file RET
>>
>> Click Value Menu button.  Choose String in the menu.
>>
>> 1. First bug: Cursor should be in the edit field.  But it is on top of
>> the Value Menu button.
>
> Confirmed.

This is because widget-button-click-moves-point is set to t for
customize buffers, and also because there is no mechanism implemented
for widgets to "pass focus" to others.  If it is a desired feature, I
can try to come up with something.

>> 2. Put cursor at beginning of the edit field.  Hit `M-TAB'.
>>
>> You see this error message: "lookup-words: lookup-words error: No plain
>> word-list found at systemdefault locations.  Customize
>> `ispell-alternate-dictionary' to set yours."
>>
>> But the cursor is moved back on top of the tag `String:', before the
>> `:' (second bug).
>
> I don't get the error message, but a "*Choices*" buffer (because my
> ispell-alternate-dictionary _is_ properly configured), but that buffer
> shows hits for "String".  Here's a sample:
>
> (0) /Usr/Dict/Web2:190067:String       (1)
/Usr/Dict/Web2:190068:Stringboard
> (2) /Usr/Dict/Web2:190069:Stringcourse (3) /Usr/Dict/Web2:190070:Stringend
>
> etc. -- quite un-useful.  IOW, it _really_ tries to complete the word
> "String", which is not what the user wants.

This is because the completion function used for string widgets is
ispell-complete-word and that command will look back from point until it
finds a word to complete.
I can't think of another way of fixing this other than peeking what will
ispell-complete-word try to complete, so I attach a patch that does
that.

> (Shouldn't the type of the widget be "file" instead of "string"?)

I think so.
From ce90f6442ca40f030d3de446cd9f57c53804d7fe Mon Sep 17 00:00:00 2001
From: Mauro Aranda <[email-masked]>
Date: Wed, 25 Sep 2019 19:40:35 -0300
Subject: [PATCH] Only complete words inside of the string widget

* lisp/wid-edit.el ('string widget): Peek the word that
ispell-complete-word will try to complete, and only offer completions
when the word is inside of the field.  (Bug#11046)
---
 lisp/wid-edit.el | 7 ++++++-
 1 file changed, 6 insertions(+), 1 deletion(-)

diff --git a/lisp/wid-edit.el b/lisp/wid-edit.el
index 916d41a..9a634b7 100644
--- a/lisp/wid-edit.el
+++ b/lisp/wid-edit.el
@@ -3073,7 +3073,12 @@ 'string
   "A string."
   :tag "String"
   :format "%{%t%}: %v"
-  :complete-function 'ispell-complete-word
+  :complete (lambda (widget)
+              (eval-and-compile (require 'ispell)) ; For `ispell-get-word'.
+              (let ((start (save-excursion (nth 1 (ispell-get-word nil)))))
+                (if (< start (widget-field-start widget))
+                    (message "No word to complete inside field")
+                  (ispell-complete-word))))
   :prompt-history 'widget-string-prompt-value-history)
 
 (define-widget 'regexp 'string
-- 
2.7.4